#!/usr/bin/env python
# -*- coding: utf-8 -*-

## @package dbus_vrm
# package contains all the shared functions from the vrm package. In other words: all functions that are
# usefull to both the vrm-logger and the pubsub implementation.

def get_vrm_portal_id():
	# For the CCGX, the definition of the VRM Portal ID is that it is the mac address of the onboard-
	# ethernet port (eth0), stripped from its colons (:) and lower case.

	# nice coincidence is that this also works fine when running on your (linux) development computer.

	# Assume we are on linux
	import fcntl, socket, struct

	s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
	info = fcntl.ioctl(s.fileno(), 0x8927,  struct.pack('256s', 'eth0'[:15]))
	macAddress = ''.join(['%02x' % ord(char) for char in info[18:24]])
	return macAddress
